/*********************************************************************************
Prctica 1 de Procesadores del Lenguaje I
Nombre: Oscar Martnez Valpuesta
Objetivo: Implementar un programa lex que reconozca la linea de comandos y
	muestre diferentes mensajes ante diferentes opciones. 
Versin: versin para lex
**********************************************************************************/

%{
char *entrada;		/* string de entrada */
int modo;	/* 0 FALSE, 1 TRUE */
#undef input
#undef unput 
#define unput(c) (*--entrada=c)
#define input() (*entrada++) 
%}

ayuda -help|-h|-? 
verbose	-v|-verbose
fichero	-f|-file
%s FNAME

%%
<FNAME>[ ][^ ]+ {printf("%s%s\n", "Se esta usando el fichero ", yytext);
		BEGIN 0;}
<FNAME>[ ]+ {printf("%s\n","ERROR, nombre se fichero no introducido.");
		BEGIN 0;}
{ayuda} printf("%s\n", "Modo de uso: comando [-help | -h | -?] [-verbose | -v] [(-file | -f) filename]");
{verbose} {if (modo == 1) {
		printf("%s\n","verbose mode on");
		modo = 0;}
	  else {
		printf("%s\n", "verbose mode off");
		modo = 1;}
	  } 
{fichero} BEGIN FNAME;
[ ] ;
%%

main(int argc, char *argv[]) {
int i;
int j;
int posicion;

  posicion = 0;
  modo = 1;
  entrada = (char *)malloc(50*sizeof(char));
  for (i = 1; i < argc; i++) {
    /* pasamos a entrada todos los argumentos de la linea de comandos */
    for (j = 0; j < strlen(argv[i]); j++) 
      entrada[posicion++] = argv[i][j];
    entrada[posicion++] = ' '; 

  }
  entrada[posicion] = '\0';
  yylex();      

}

yywrap() {
   return 1;
}
