/*
 * Expresiones con restas y productos 
 */

%{
  #define YYDEBUG 1 
%}

%token DIGIT

%%
S : E '\n'	{printf("%d\n",$1);}
E : E '-'T 	{$$=$1-$3;}
  |T
  ;
T : T '*' F 	{$$=$1*$3;}
  |F
  ;
F : '(' E ')'	{$$=$2;}
  | DIGIT
  ;
%%

main()
{
  extern int yydebug;
  yydebug = 1;

  yyparse();
} /* main */
