/*
 * Expresiones con sumas, restas, multiplicaciones, divisiones y divisin con mdulo. 
 */

%{
  #define YYDEBUG 1 
%}

%token NUM
%left '+''-'
%left '*''/''%'
%left '('')'	/* no necesario */
%left UNARIO
%%
S : S '\n'E	{printf("%d\n",$3);}
  | E		{printf("%d\n",$1);}
  ;
E : E '+' E 	{$$=$1+$3;}
  | E '-' E	{$$=$1-$3;}
  | E '*' E	{$$=$1*$3;}
  | E '/' E	{$$=$1/$3;}
  | E '%' E	{$$=$1%$3;}
  | '(' E ')'	{$$=$2;}
  | '-' E %prec UNARIO {$$=-$2;} 
  | NUM
  ;
%%

main()
{
  extern int yydebug;
  yydebug = 0;

  yyparse();
} /* main */
