
# line 5 "formateador.y"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#define YYDEBUG 1
#include "symbol.h"
extern FILE *yyin;
FILE *output;
int nivel = 0;
int expr = 1;


# line 17 "formateador.y"
typedef union
#ifdef __cplusplus
	YYSTYPE
#endif
 { 
	struct entry *ptr;
	int value;
} YYSTYPE;
# define ID 257
# define CONST 258
# define IF 259
# define ELSE 260
# define WHILE 261
# define BREAK 262
# define CONTINUE 263
# define RETURN 264
# define GE 265
# define LE 266
# define EQ 267
# define NE 268
# define PE 269
# define ME 270
# define TE 271
# define DE 272
# define RE 273
# define PP 274
# define MM 275
# define INT 276
# define UNARIO 277

#include <inttypes.h>

#ifdef __STDC__
#include <stdlib.h>
#include <string.h>
#else
#include <malloc.h>
#include <memory.h>
#endif

#include <values.h>

#if defined(__cplusplus) || defined(__STDC__)

#if defined(__cplusplus) && defined(__EXTERN_C__)
extern "C" {
#endif
#ifndef yyerror
#if defined(__cplusplus)
	void yyerror(const char *);
#endif
#endif
#ifndef yylex
	int yylex(void);
#endif
	int yyparse(void);
#if defined(__cplusplus) && defined(__EXTERN_C__)
}
#endif

#endif

#define yyclearin yychar = -1
#define yyerrok yyerrflag = 0
extern int yychar;
extern int yyerrflag;
YYSTYPE yylval;
YYSTYPE yyval;
typedef int yytabelem;
#ifndef YYMAXDEPTH
#define YYMAXDEPTH 150
#endif
#if YYMAXDEPTH > 0
int yy_yys[YYMAXDEPTH], *yys = yy_yys;
YYSTYPE yy_yyv[YYMAXDEPTH], *yyv = yy_yyv;
#else	/* user does initial allocation */
int *yys;
YYSTYPE *yyv;
#endif
static int yymaxdepth = YYMAXDEPTH;
# define YYERRCODE 256

# line 182 "formateador.y"


/* Funcion que imprime tantos tabuladores como indique t */
void tab(int t) {
int i;

  for (i=0;i < t;i++) fprintf(output,"   ");
}

void imp(char *s) {

  fprintf(output,"%s", s);
}

/* Funcin principal */
main( int argc, char ** argv ){
FILE *file;
extern yydebug;


  yydebug = 0;
  /* comprobacion de parametros y apertura del fichero */
  if (argc > 1){
    file = fopen(argv[1], "r");
    if ( !file ){
      fprintf(stderr, "no se puede abrir %s\n", argv[1] );
      exit(1);
    }
  } /* if */
  else {
    printf("Forma de uso: a.out fichero.c\n");
    exit (1);
  }

   yyin = file;
  /* creamos el fichero de salida */
  output = fopen("salida.bak","w+");
  if (!output) {
    fprintf(stderr, "\nNo se puede crear el fichero de salida\n");
    exit(1);
  }

  /* Creamos la tabla de palabras reservadas */
   CrearRWtable(); 

  /* Creamos la tabla de simbolos */

  init();
  
  yyparse();
  fclose(output);
  fclose(file);
}
static const yytabelem yyexca[] ={
-1, 1,
	0, -1,
	-2, 0,
-1, 48,
	59, 37,
	-2, 39,
	};
# define YYNPROD 109
# define YYLAST 381
static const yytabelem yyact[]={

    19,     8,    11,   168,    26,    11,    39,    24,    19,    28,
    77,    78,    49,    16,    72,    75,    73,    38,    74,    29,
    76,     8,    30,    35,    77,    78,    30,    29,    19,    75,
    73,    29,    74,    81,    76,    82,    19,    31,    26,    19,
    26,    29,    60,    19,   160,     7,    63,    81,    20,    82,
    77,    78,    13,   128,    14,    75,    73,    87,    74,    33,
    76,    77,     6,    22,    77,   133,    75,    80,    21,    75,
    73,    76,    74,    81,    76,    82,    32,    56,    95,     4,
    94,    80,   107,    16,    97,    40,    53,    81,    77,    82,
   121,    16,    42,    75,    73,    62,    74,    79,    76,   120,
    43,   129,   119,   100,   118,   117,   130,    65,    15,   136,
   137,    81,   116,    82,    15,   115,   114,   113,   135,   112,
   139,   140,   141,   142,   143,   144,   145,   146,   147,   148,
   149,   150,   151,   152,   153,   154,   155,   156,   157,   158,
   159,   162,    41,   164,   165,   161,     9,   134,    58,   111,
   110,    96,   109,    12,   108,   127,   126,    62,    18,   101,
   102,    18,   125,    27,   106,   124,   123,   122,   166,    71,
    70,   107,    69,    77,   169,    37,    68,    45,    75,    73,
    59,    74,   167,    76,    44,    64,    36,    61,    34,    23,
    17,     5,     3,    66,    67,     2,     1,     0,     0,     0,
     0,    93,     0,     0,     0,     0,     0,     0,     0,    98,
     0,   103,   104,   105,     0,     0,     0,    11,    57,    50,
    11,    51,    46,    47,    48,    11,    57,    50,     0,    51,
    46,    47,    48,     0,    54,    55,     0,     0,    83,    84,
    85,    86,    54,    55,     0,    11,    57,     0,     0,   138,
     0,     0,    83,    84,    85,    86,    11,    57,     0,     0,
     0,     0,    54,    55,     0,    88,    89,    90,    91,    92,
     0,     0,     0,    54,    55,     0,     0,   163,    83,    84,
    85,    86,     0,     0,    52,     0,     0,    10,     0,     0,
     0,    10,    83,    84,    85,    86,     0,     0,     0,     0,
     0,     0,     0,    25,     0,     0,     0,     0,     0,     0,
     0,     0,     0,    10,     0,     0,    83,    84,    10,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,    10,    99,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,   131,
   132 };
static const yytabelem yypact[]={

-10000000,-10000000,  -255,-10000000,-10000000,-10000000,  -252,  -110,-10000000,     3,
-10000000,-10000000,     3,  -110,-10000000,-10000000,-10000000,-10000000,   -37,-10000000,
   -18,-10000000,  -275,-10000000,-10000000,-10000000,-10000000,-10000000,  -252,-10000000,
-10000000,   -40,-10000000,  -252,    -3,  -275,   -22,-10000000,-10000000,-10000000,
-10000000,-10000000,   -28,-10000000,     3,     3,-10000000,-10000000,-10000000,   -27,
-10000000,-10000000,    -4,-10000000,-10000000,-10000000,-10000000,-10000000,   -12,-10000000,
-10000000,-10000000,  -252,  -252,-10000000,  -275,   -12,   -12,   -28,   -28,
   -28,   -12,   -22,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,
-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,
-10000000,-10000000,-10000000,    -1,  -252,  -252,-10000000,  -275,-10000000,-10000000,
   -40,    -3,    -3,-10000000,-10000000,-10000000,   -28,   -12,   -12,   -12,
   -12,   -12,   -12,   -12,   -12,   -12,   -12,   -12,   -12,   -12,
   -12,   -12,   -12,   -12,   -12,   -12,   -12,   -12,-10000000,-10000000,
   -27,-10000000,-10000000,    -3,   -18,-10000000,   -32,   -32,-10000000,   -27,
    24,    24,-10000000,-10000000,-10000000,    27,   -13,    13,   136,   136,
   136,   136,    51,    51,   -27,   -27,   -27,   -27,   -27,   -27,
    -3,   -22,-10000000,-10000000,  -257,-10000000,-10000000,   -32,-10000000,-10000000 };
static const yytabelem yypgo[]={

     0,   196,   195,   192,    76,   191,    59,   146,    48,   142,
     9,   284,    45,    54,   190,   148,   189,   188,     7,    23,
   187,   186,   100,    63,    37,    17,     6,    92,   184,   182,
   177,   176,   172,   170,   169,    12,    14,   167,   166,   165,
   162,   156,   155,   154,   152,   150,   149,   119,   117,   116,
   115,   112,   105,   104,   102,    99,    90,    86,    80,    78,
    77,    65,    53,    44 };
static const yytabelem yyr1[]={

     0,     1,     2,     2,     3,     3,     4,     8,     8,     7,
     5,     5,    12,    17,    14,    14,    19,    19,    16,    21,
    21,    20,    13,    23,    23,    24,    24,    26,    26,    26,
    26,    26,    26,    31,    26,    32,    26,    33,    26,    34,
    26,    27,    36,    36,    37,    35,    38,    35,    39,    35,
    40,    35,    41,    35,    42,    35,    43,    35,    44,    35,
    45,    35,    46,    35,    47,    35,    48,    35,    49,    35,
    50,    35,    51,    35,    52,    35,    53,    35,    54,    35,
    55,    35,    56,    35,    35,    58,    57,    59,    57,    57,
    60,    60,    61,    60,    63,    60,    60,    62,     6,    10,
     9,    11,    15,    18,    22,    25,    28,    29,    30 };
static const yytabelem yyr2[]={

     0,     2,     0,     4,     2,     2,     8,     0,     6,     2,
     4,     6,     4,     1,    10,     6,     0,     4,     4,     0,
     6,     8,     8,     0,     4,     0,     4,     2,     4,     8,
    10,    14,    10,     1,     6,     1,     6,     1,     6,     1,
     8,     4,     0,     6,     1,     8,     1,     8,     1,     8,
     1,     8,     1,     8,     1,     8,     1,     8,     1,     8,
     1,     8,     1,     8,     1,     8,     1,     8,     1,     8,
     1,     8,     1,     8,     1,     8,     1,     8,     1,     8,
     1,     8,     1,     8,     2,     1,     6,     1,     6,     2,
     2,     3,     1,     8,     1,    10,     6,     4,     3,     3,
     3,     3,     3,     3,     3,     3,     3,     3,     3 };
static const yytabelem yychk[]={

-10000000,    -1,    -2,    -3,    -4,    -5,    -6,   -12,   276,    -7,
   -11,   257,    -7,   -12,   -13,   -22,   123,   -14,   -15,    40,
    -8,   -13,   -23,   -16,   -18,   -11,    41,    -9,   -10,    59,
    44,   -24,    -4,    -6,   -17,   -19,   -21,    -7,   -25,   -26,
   125,    -9,   -27,   -22,   -28,   -30,   262,   263,   264,   -35,
   259,   261,   -11,   -57,   274,   275,   -60,   258,   -15,    -7,
   -18,   -20,    -6,   -10,    -9,   -23,   -15,   -15,   -31,   -32,
   -33,   -34,   -36,    43,    45,    42,    47,    37,    38,   124,
    94,    60,    62,   265,   266,   267,   268,    61,   269,   270,
   271,   272,   273,   -15,   -58,   -59,   -27,   -19,    -7,   -11,
   -24,   -27,   -27,    -9,    -9,    -9,   -27,   -10,   -43,   -44,
   -45,   -46,   -47,   -48,   -49,   -50,   -51,   -52,   -53,   -54,
   -55,   -56,   -37,   -38,   -39,   -40,   -41,   -42,   -62,   -18,
   -35,   -11,   -11,   -61,    -8,   -25,   -18,   -18,    -9,   -35,
   -35,   -35,   -35,   -35,   -35,   -35,   -35,   -35,   -35,   -35,
   -35,   -35,   -35,   -35,   -35,   -35,   -35,   -35,   -35,   -35,
   -63,   -36,   -18,    -9,   -26,   -26,   -18,   -29,   260,   -26 };
static const yytabelem yydef[]={

     2,    -2,     1,     3,     4,     5,     0,     0,    98,     0,
     9,   101,     7,     0,    10,    23,   104,    12,     0,   102,
     0,    11,    25,    13,    16,    19,   103,     6,     0,   100,
    99,     0,    24,     0,     0,    15,    18,     8,    22,    26,
   105,    27,     0,    23,     0,     0,    33,    35,    -2,    42,
   106,   108,    90,    84,    85,    87,    89,    91,     0,     7,
    16,    17,     0,     0,    28,    25,     0,     0,     0,     0,
     0,     0,    41,    56,    58,    60,    62,    64,    66,    68,
    70,    72,    74,    76,    78,    80,    82,    44,    46,    48,
    50,    52,    54,     0,     0,     0,    92,    14,     7,    20,
     0,     0,     0,    34,    36,    38,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,    94,    96,
    42,    86,    88,     0,     0,    29,     0,     0,    40,    43,
    57,    59,    61,    63,    65,    67,    69,    71,    73,    75,
    77,    79,    81,    83,    45,    47,    49,    51,    53,    55,
     0,    97,    93,    21,    30,    32,    95,     0,   107,    31 };
typedef struct
#ifdef __cplusplus
	yytoktype
#endif
{ char *t_name; int t_val; } yytoktype;
#ifndef YYDEBUG
#	define YYDEBUG	0	/* don't allow debugging */
#endif

#if YYDEBUG

yytoktype yytoks[] =
{
	"ID",	257,
	"CONST",	258,
	"IF",	259,
	"ELSE",	260,
	"WHILE",	261,
	"BREAK",	262,
	"CONTINUE",	263,
	"RETURN",	264,
	"GE",	265,
	"LE",	266,
	"EQ",	267,
	"NE",	268,
	"PE",	269,
	"ME",	270,
	"TE",	271,
	"DE",	272,
	"RE",	273,
	"PP",	274,
	"MM",	275,
	"INT",	276,
	";",	59,
	"=",	61,
	"|",	124,
	"^",	94,
	"&",	38,
	"<",	60,
	">",	62,
	"+",	43,
	"-",	45,
	"*",	42,
	"/",	47,
	"%",	37,
	"UNARIO",	277,
	"(",	40,
	")",	41,
	"-unknown-",	-1	/* ends search */
};

char * yyreds[] =
{
	"-no such reduction-",
	"program : definitionL",
	"definitionL : /* empty */",
	"definitionL : definitionL definition",
	"definition : dataDefinition",
	"definition : functionDefinition",
	"dataDefinition : impINT declarator declaratorL impPYC",
	"declaratorL : /* empty */",
	"declaratorL : declaratorL impC declarator",
	"declarator : impID",
	"functionDefinition : functionHeader functionBody",
	"functionDefinition : impINT functionHeader functionBody",
	"functionHeader : declarator parameterList",
	"parameterList : impAP identifierList",
	"parameterList : impAP identifierList impCP parameterDeclarationL",
	"parameterList : impAP impCP parameterDeclarationL",
	"parameterDeclarationL : /* empty */",
	"parameterDeclarationL : parameterDeclarationL parameterDeclaration",
	"identifierList : impID IDL",
	"IDL : /* empty */",
	"IDL : IDL impC impID",
	"parameterDeclaration : impINT declarator declaratorL impPYC",
	"functionBody : impALL dataDefinitionL stamentL impCLL",
	"dataDefinitionL : /* empty */",
	"dataDefinitionL : dataDefinitionL dataDefinition",
	"stamentL : /* empty */",
	"stamentL : stamentL stament",
	"stament : impPYC",
	"stament : expression impPYC",
	"stament : impALL dataDefinitionL stamentL impCLL",
	"stament : impIF impAP expression impCP stament",
	"stament : impIF impAP expression impCP stament impELSE stament",
	"stament : impWHILE impAP expression impCP stament",
	"stament : BREAK",
	"stament : BREAK impPYC",
	"stament : CONTINUE",
	"stament : CONTINUE impPYC",
	"stament : RETURN",
	"stament : RETURN impPYC",
	"stament : RETURN",
	"stament : RETURN expression impPYC",
	"expression : binary binaryL",
	"binaryL : /* empty */",
	"binaryL : binaryL impC binary",
	"binary : impID '='",
	"binary : impID '=' binary",
	"binary : impID PE",
	"binary : impID PE binary",
	"binary : impID ME",
	"binary : impID ME binary",
	"binary : impID TE",
	"binary : impID TE binary",
	"binary : impID DE",
	"binary : impID DE binary",
	"binary : impID RE",
	"binary : impID RE binary",
	"binary : binary '+'",
	"binary : binary '+' binary",
	"binary : binary '-'",
	"binary : binary '-' binary",
	"binary : binary '*'",
	"binary : binary '*' binary",
	"binary : binary '/'",
	"binary : binary '/' binary",
	"binary : binary '%'",
	"binary : binary '%' binary",
	"binary : binary '&'",
	"binary : binary '&' binary",
	"binary : binary '|'",
	"binary : binary '|' binary",
	"binary : binary '^'",
	"binary : binary '^' binary",
	"binary : binary '<'",
	"binary : binary '<' binary",
	"binary : binary '>'",
	"binary : binary '>' binary",
	"binary : binary GE",
	"binary : binary GE binary",
	"binary : binary LE",
	"binary : binary LE binary",
	"binary : binary EQ",
	"binary : binary EQ binary",
	"binary : binary NE",
	"binary : binary NE binary",
	"binary : unary",
	"unary : PP",
	"unary : PP impID",
	"unary : MM",
	"unary : MM impID",
	"unary : primary",
	"primary : impID",
	"primary : CONST",
	"primary : impAP expression",
	"primary : impAP expression impCP",
	"primary : impID impAP argumentList",
	"primary : impID impAP argumentList impCP",
	"primary : impID impAP impCP",
	"argumentList : binary binaryL",
	"impINT : INT",
	"impC : ','",
	"impPYC : ';'",
	"impID : ID",
	"impAP : '('",
	"impCP : ')'",
	"impALL : '{'",
	"impCLL : '}'",
	"impIF : IF",
	"impELSE : ELSE",
	"impWHILE : WHILE",
};
#endif /* YYDEBUG */
# line	1 "/usr/ccs/bin/yaccpar"
/*
 * Copyright (c) 1993 by Sun Microsystems, Inc.
 */

#pragma ident	"@(#)yaccpar	6.15	97/12/08 SMI"

/*
** Skeleton parser driver for yacc output
*/

/*
** yacc user known macros and defines
*/
#define YYERROR		goto yyerrlab
#define YYACCEPT	return(0)
#define YYABORT		return(1)
#define YYBACKUP( newtoken, newvalue )\
{\
	if ( yychar >= 0 || ( yyr2[ yytmp ] >> 1 ) != 1 )\
	{\
		yyerror( "syntax error - cannot backup" );\
		goto yyerrlab;\
	}\
	yychar = newtoken;\
	yystate = *yyps;\
	yylval = newvalue;\
	goto yynewstate;\
}
#define YYRECOVERING()	(!!yyerrflag)
#define YYNEW(type)	malloc(sizeof(type) * yynewmax)
#define YYCOPY(to, from, type) \
	(type *) memcpy(to, (char *) from, yymaxdepth * sizeof (type))
#define YYENLARGE( from, type) \
	(type *) realloc((char *) from, yynewmax * sizeof(type))
#ifndef YYDEBUG
#	define YYDEBUG	1	/* make debugging available */
#endif

/*
** user known globals
*/
int yydebug;			/* set to 1 to get debugging */

/*
** driver internal defines
*/
#define YYFLAG		(-10000000)

/*
** global variables used by the parser
*/
YYSTYPE *yypv;			/* top of value stack */
int *yyps;			/* top of state stack */

int yystate;			/* current state */
int yytmp;			/* extra var (lasts between blocks) */

int yynerrs;			/* number of errors */
int yyerrflag;			/* error recovery flag */
int yychar;			/* current input token number */



#ifdef YYNMBCHARS
#define YYLEX()		yycvtok(yylex())
/*
** yycvtok - return a token if i is a wchar_t value that exceeds 255.
**	If i<255, i itself is the token.  If i>255 but the neither 
**	of the 30th or 31st bit is on, i is already a token.
*/
#if defined(__STDC__) || defined(__cplusplus)
int yycvtok(int i)
#else
int yycvtok(i) int i;
#endif
{
	int first = 0;
	int last = YYNMBCHARS - 1;
	int mid;
	wchar_t j;

	if(i&0x60000000){/*Must convert to a token. */
		if( yymbchars[last].character < i ){
			return i;/*Giving up*/
		}
		while ((last>=first)&&(first>=0)) {/*Binary search loop*/
			mid = (first+last)/2;
			j = yymbchars[mid].character;
			if( j==i ){/*Found*/ 
				return yymbchars[mid].tvalue;
			}else if( j<i ){
				first = mid + 1;
			}else{
				last = mid -1;
			}
		}
		/*No entry in the table.*/
		return i;/* Giving up.*/
	}else{/* i is already a token. */
		return i;
	}
}
#else/*!YYNMBCHARS*/
#define YYLEX()		yylex()
#endif/*!YYNMBCHARS*/

/*
** yyparse - return 0 if worked, 1 if syntax error not recovered from
*/
#if defined(__STDC__) || defined(__cplusplus)
int yyparse(void)
#else
int yyparse()
#endif
{
	register YYSTYPE *yypvt = 0;	/* top of value stack for $vars */

#if defined(__cplusplus) || defined(lint)
/*
	hacks to please C++ and lint - goto's inside
	switch should never be executed
*/
	static int __yaccpar_lint_hack__ = 0;
	switch (__yaccpar_lint_hack__)
	{
		case 1: goto yyerrlab;
		case 2: goto yynewstate;
	}
#endif

	/*
	** Initialize externals - yyparse may be called more than once
	*/
	yypv = &yyv[-1];
	yyps = &yys[-1];
	yystate = 0;
	yytmp = 0;
	yynerrs = 0;
	yyerrflag = 0;
	yychar = -1;

#if YYMAXDEPTH <= 0
	if (yymaxdepth <= 0)
	{
		if ((yymaxdepth = YYEXPAND(0)) <= 0)
		{
			yyerror("yacc initialization error");
			YYABORT;
		}
	}
#endif

	{
		register YYSTYPE *yy_pv;	/* top of value stack */
		register int *yy_ps;		/* top of state stack */
		register int yy_state;		/* current state */
		register int  yy_n;		/* internal state number info */
	goto yystack;	/* moved from 6 lines above to here to please C++ */

		/*
		** get globals into registers.
		** branch to here only if YYBACKUP was called.
		*/
	yynewstate:
		yy_pv = yypv;
		yy_ps = yyps;
		yy_state = yystate;
		goto yy_newstate;

		/*
		** get globals into registers.
		** either we just started, or we just finished a reduction
		*/
	yystack:
		yy_pv = yypv;
		yy_ps = yyps;
		yy_state = yystate;

		/*
		** top of for (;;) loop while no reductions done
		*/
	yy_stack:
		/*
		** put a state and value onto the stacks
		*/
#if YYDEBUG
		/*
		** if debugging, look up token value in list of value vs.
		** name pairs.  0 and negative (-1) are special values.
		** Note: linear search is used since time is not a real
		** consideration while debugging.
		*/
		if ( yydebug )
		{
			register int yy_i;

			printf( "State %d, token ", yy_state );
			if ( yychar == 0 )
				printf( "end-of-file\n" );
			else if ( yychar < 0 )
				printf( "-none-\n" );
			else
			{
				for ( yy_i = 0; yytoks[yy_i].t_val >= 0;
					yy_i++ )
				{
					if ( yytoks[yy_i].t_val == yychar )
						break;
				}
				printf( "%s\n", yytoks[yy_i].t_name );
			}
		}
#endif /* YYDEBUG */
		if ( ++yy_ps >= &yys[ yymaxdepth ] )	/* room on stack? */
		{
			/*
			** reallocate and recover.  Note that pointers
			** have to be reset, or bad things will happen
			*/
			long yyps_index = (yy_ps - yys);
			long yypv_index = (yy_pv - yyv);
			long yypvt_index = (yypvt - yyv);
			int yynewmax;
#ifdef YYEXPAND
			yynewmax = YYEXPAND(yymaxdepth);
#else
			yynewmax = 2 * yymaxdepth;	/* double table size */
			if (yymaxdepth == YYMAXDEPTH)	/* first time growth */
			{
				char *newyys = (char *)YYNEW(int);
				char *newyyv = (char *)YYNEW(YYSTYPE);
				if (newyys != 0 && newyyv != 0)
				{
					yys = YYCOPY(newyys, yys, int);
					yyv = YYCOPY(newyyv, yyv, YYSTYPE);
				}
				else
					yynewmax = 0;	/* failed */
			}
			else				/* not first time */
			{
				yys = YYENLARGE(yys, int);
				yyv = YYENLARGE(yyv, YYSTYPE);
				if (yys == 0 || yyv == 0)
					yynewmax = 0;	/* failed */
			}
#endif
			if (yynewmax <= yymaxdepth)	/* tables not expanded */
			{
				yyerror( "yacc stack overflow" );
				YYABORT;
			}
			yymaxdepth = yynewmax;

			yy_ps = yys + yyps_index;
			yy_pv = yyv + yypv_index;
			yypvt = yyv + yypvt_index;
		}
		*yy_ps = yy_state;
		*++yy_pv = yyval;

		/*
		** we have a new state - find out what to do
		*/
	yy_newstate:
		if ( ( yy_n = yypact[ yy_state ] ) <= YYFLAG )
			goto yydefault;		/* simple state */
#if YYDEBUG
		/*
		** if debugging, need to mark whether new token grabbed
		*/
		yytmp = yychar < 0;
#endif
		if ( ( yychar < 0 ) && ( ( yychar = YYLEX() ) < 0 ) )
			yychar = 0;		/* reached EOF */
#if YYDEBUG
		if ( yydebug && yytmp )
		{
			register int yy_i;

			printf( "Received token " );
			if ( yychar == 0 )
				printf( "end-of-file\n" );
			else if ( yychar < 0 )
				printf( "-none-\n" );
			else
			{
				for ( yy_i = 0; yytoks[yy_i].t_val >= 0;
					yy_i++ )
				{
					if ( yytoks[yy_i].t_val == yychar )
						break;
				}
				printf( "%s\n", yytoks[yy_i].t_name );
			}
		}
#endif /* YYDEBUG */
		if ( ( ( yy_n += yychar ) < 0 ) || ( yy_n >= YYLAST ) )
			goto yydefault;
		if ( yychk[ yy_n = yyact[ yy_n ] ] == yychar )	/*valid shift*/
		{
			yychar = -1;
			yyval = yylval;
			yy_state = yy_n;
			if ( yyerrflag > 0 )
				yyerrflag--;
			goto yy_stack;
		}

	yydefault:
		if ( ( yy_n = yydef[ yy_state ] ) == -2 )
		{
#if YYDEBUG
			yytmp = yychar < 0;
#endif
			if ( ( yychar < 0 ) && ( ( yychar = YYLEX() ) < 0 ) )
				yychar = 0;		/* reached EOF */
#if YYDEBUG
			if ( yydebug && yytmp )
			{
				register int yy_i;

				printf( "Received token " );
				if ( yychar == 0 )
					printf( "end-of-file\n" );
				else if ( yychar < 0 )
					printf( "-none-\n" );
				else
				{
					for ( yy_i = 0;
						yytoks[yy_i].t_val >= 0;
						yy_i++ )
					{
						if ( yytoks[yy_i].t_val
							== yychar )
						{
							break;
						}
					}
					printf( "%s\n", yytoks[yy_i].t_name );
				}
			}
#endif /* YYDEBUG */
			/*
			** look through exception table
			*/
			{
				register const int *yyxi = yyexca;

				while ( ( *yyxi != -1 ) ||
					( yyxi[1] != yy_state ) )
				{
					yyxi += 2;
				}
				while ( ( *(yyxi += 2) >= 0 ) &&
					( *yyxi != yychar ) )
					;
				if ( ( yy_n = yyxi[1] ) < 0 )
					YYACCEPT;
			}
		}

		/*
		** check for syntax error
		*/
		if ( yy_n == 0 )	/* have an error */
		{
			/* no worry about speed here! */
			switch ( yyerrflag )
			{
			case 0:		/* new error */
				yyerror( "syntax error" );
				goto skip_init;
			yyerrlab:
				/*
				** get globals into registers.
				** we have a user generated syntax type error
				*/
				yy_pv = yypv;
				yy_ps = yyps;
				yy_state = yystate;
			skip_init:
				yynerrs++;
				/* FALLTHRU */
			case 1:
			case 2:		/* incompletely recovered error */
					/* try again... */
				yyerrflag = 3;
				/*
				** find state where "error" is a legal
				** shift action
				*/
				while ( yy_ps >= yys )
				{
					yy_n = yypact[ *yy_ps ] + YYERRCODE;
					if ( yy_n >= 0 && yy_n < YYLAST &&
						yychk[yyact[yy_n]] == YYERRCODE)					{
						/*
						** simulate shift of "error"
						*/
						yy_state = yyact[ yy_n ];
						goto yy_stack;
					}
					/*
					** current state has no shift on
					** "error", pop stack
					*/
#if YYDEBUG
#	define _POP_ "Error recovery pops state %d, uncovers state %d\n"
					if ( yydebug )
						printf( _POP_, *yy_ps,
							yy_ps[-1] );
#	undef _POP_
#endif
					yy_ps--;
					yy_pv--;
				}
				/*
				** there is no state on stack with "error" as
				** a valid shift.  give up.
				*/
				YYABORT;
			case 3:		/* no shift yet; eat a token */
#if YYDEBUG
				/*
				** if debugging, look up token in list of
				** pairs.  0 and negative shouldn't occur,
				** but since timing doesn't matter when
				** debugging, it doesn't hurt to leave the
				** tests here.
				*/
				if ( yydebug )
				{
					register int yy_i;

					printf( "Error recovery discards " );
					if ( yychar == 0 )
						printf( "token end-of-file\n" );
					else if ( yychar < 0 )
						printf( "token -none-\n" );
					else
					{
						for ( yy_i = 0;
							yytoks[yy_i].t_val >= 0;
							yy_i++ )
						{
							if ( yytoks[yy_i].t_val
								== yychar )
							{
								break;
							}
						}
						printf( "token %s\n",
							yytoks[yy_i].t_name );
					}
				}
#endif /* YYDEBUG */
				if ( yychar == 0 )	/* reached EOF. quit */
					YYABORT;
				yychar = -1;
				goto yy_newstate;
			}
		}/* end if ( yy_n == 0 ) */
		/*
		** reduction by production yy_n
		** put stack tops, etc. so things right after switch
		*/
#if YYDEBUG
		/*
		** if debugging, print the string that is the user's
		** specification of the reduction which is just about
		** to be done.
		*/
		if ( yydebug )
			printf( "Reduce by (%d) \"%s\"\n",
				yy_n, yyreds[ yy_n ] );
#endif
		yytmp = yy_n;			/* value to switch over */
		yypvt = yy_pv;			/* $vars top of value stack */
		/*
		** Look in goto table for next state
		** Sorry about using yy_state here as temporary
		** register variable, but why not, if it works...
		** If yyr2[ yy_n ] doesn't have the low order bit
		** set, then there is no action to be done for
		** this reduction.  So, no saving & unsaving of
		** registers done.  The only difference between the
		** code just after the if and the body of the if is
		** the goto yy_stack in the body.  This way the test
		** can be made before the choice of what to do is needed.
		*/
		{
			/* length of production doubled with extra bit */
			register int yy_len = yyr2[ yy_n ];

			if ( !( yy_len & 01 ) )
			{
				yy_len >>= 1;
				yyval = ( yy_pv -= yy_len )[1];	/* $$ = $1 */
				yy_state = yypgo[ yy_n = yyr1[ yy_n ] ] +
					*( yy_ps -= yy_len ) + 1;
				if ( yy_state >= YYLAST ||
					yychk[ yy_state =
					yyact[ yy_state ] ] != -yy_n )
				{
					yy_state = yyact[ yypgo[ yy_n ] ];
				}
				goto yy_stack;
			}
			yy_len >>= 1;
			yyval = ( yy_pv -= yy_len )[1];	/* $$ = $1 */
			yy_state = yypgo[ yy_n = yyr1[ yy_n ] ] +
				*( yy_ps -= yy_len ) + 1;
			if ( yy_state >= YYLAST ||
				yychk[ yy_state = yyact[ yy_state ] ] != -yy_n )
			{
				yy_state = yyact[ yypgo[ yy_n ] ];
			}
		}
					/* save until reenter driver code */
		yystate = yy_state;
		yyps = yy_ps;
		yypv = yy_pv;
	}
	/*
	** code supplied by user is placed in this switch
	*/
	switch( yytmp )
	{
		
case 13:
# line 76 "formateador.y"
{expr = 1;} break;
case 33:
# line 103 "formateador.y"
{imp("break");} break;
case 35:
# line 104 "formateador.y"
{imp("continue");} break;
case 37:
# line 105 "formateador.y"
{imp("return");} break;
case 39:
# line 106 "formateador.y"
{imp("return ");} break;
case 44:
# line 113 "formateador.y"
{imp(" = ");} break;
case 46:
# line 114 "formateador.y"
{imp(" += ");} break;
case 48:
# line 115 "formateador.y"
{imp(" -= ");} break;
case 50:
# line 116 "formateador.y"
{imp(" *= ");} break;
case 52:
# line 117 "formateador.y"
{imp(" /= ");} break;
case 54:
# line 118 "formateador.y"
{imp(" %= ");} break;
case 56:
# line 119 "formateador.y"
{imp(" + ");} break;
case 58:
# line 120 "formateador.y"
{imp(" - ");} break;
case 60:
# line 121 "formateador.y"
{imp(" * ");} break;
case 62:
# line 122 "formateador.y"
{imp(" / ");} break;
case 64:
# line 123 "formateador.y"
{imp(" % ");} break;
case 66:
# line 124 "formateador.y"
{imp(" & ");} break;
case 68:
# line 125 "formateador.y"
{imp(" | ");} break;
case 70:
# line 126 "formateador.y"
{imp(" ^ ");} break;
case 72:
# line 127 "formateador.y"
{imp(" < ");} break;
case 74:
# line 128 "formateador.y"
{imp(" > ");} break;
case 76:
# line 129 "formateador.y"
{imp(" >= ");} break;
case 78:
# line 130 "formateador.y"
{imp(" <= ");} break;
case 80:
# line 131 "formateador.y"
{imp(" == ");} break;
case 82:
# line 132 "formateador.y"
{imp(" != ");} break;
case 85:
# line 135 "formateador.y"
{imp("++");} break;
case 87:
# line 136 "formateador.y"
{imp("--");} break;
case 91:
# line 140 "formateador.y"
{fprintf(output,"%d", yypvt[-0].value);} break;
case 92:
# line 141 "formateador.y"
{expr = 0;} break;
case 94:
# line 142 "formateador.y"
{expr = 0;} break;
case 98:
# line 147 "formateador.y"
{imp("int ");} break;
case 99:
# line 149 "formateador.y"
{imp(", ");} break;
case 100:
# line 151 "formateador.y"
{imp(";\n");
		tab(nivel);} break;
case 101:
# line 154 "formateador.y"
{imp(yypvt[-0].ptr->name);} break;
case 102:
# line 156 "formateador.y"
{imp("(");} break;
case 103:
# line 158 "formateador.y"
{if (expr == 1) {
		  imp(")\n");
		  tab(nivel);
		}
		else
		  imp(")");} break;
case 104:
# line 165 "formateador.y"
{imp("{\n");
		nivel++;
		tab(nivel);} break;
case 105:
# line 169 "formateador.y"
{nivel--;
		imp("\r");
		tab(nivel);
		imp("}\n");
		tab(nivel);} break;
case 106:
# line 175 "formateador.y"
{imp("if ");} break;
case 107:
# line 177 "formateador.y"
{imp("else\n");
		tab(nivel);} break;
case 108:
# line 180 "formateador.y"
{imp("while ");} break;
# line	531 "/usr/ccs/bin/yaccpar"
	}
	goto yystack;		/* reset registers in driver code */
}

