/****************************************************************************/
/* Oscar Martinez Valpuesta */
/****************************************************************************/
#include <stdio.h>
#include "symbol.h"


struct entry *symtab = NULL;

struct entry *create(char *name){

  struct entry *nodo;
   
    nodo = (struct entry *)malloc(sizeof(struct entry));
    if (nodo == NULL){ 
         printf(" \nMemoria Insuficiente");
         exit(-1);
    }
    nodo->name = (char *)strdup(name);
    nodo->valor = 4.0;
    nodo->next = symtab;
    symtab = nodo;
    return nodo;
}
/************************* FUNCION DE BUSQUEDA EN LA LISTA  ***************/  
struct entry *find(char *name){

  struct entry *nodo;

    nodo = symtab;
    while ((nodo != NULL) && (strcmp(nodo->name,name)))
         nodo = nodo->next;
    return nodo;
}
/************************* FUNCION DE INSERCION Y BUSQUEDA **************/
struct entry *lookUp(char *s){

  struct entry *nodo;
     
       nodo = find(s);
       if (nodo == NULL)
           return create(s);
       
       return nodo;
}
