
# line 6 "errores.y"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#define YYDEBUG 1
#include "symbol.h"
extern FILE *yyin;
FILE *output;

# line 15 "errores.y"
typedef union
#ifdef __cplusplus
	YYSTYPE
#endif
 { 
	struct entry *ptr;
	int value;
} YYSTYPE;
# define ID 257
# define CONST 258
# define IF 259
# define ELSE 260
# define WHILE 261
# define BREAK 262
# define CONTINUE 263
# define RETURN 264
# define GE 265
# define LE 266
# define EQ 267
# define NE 268
# define PE 269
# define ME 270
# define TE 271
# define DE 272
# define RE 273
# define PP 274
# define MM 275
# define INT 276
# define UNARIO 277

#include <inttypes.h>

#ifdef __STDC__
#include <stdlib.h>
#include <string.h>
#else
#include <malloc.h>
#include <memory.h>
#endif

#include <values.h>

#if defined(__cplusplus) || defined(__STDC__)

#if defined(__cplusplus) && defined(__EXTERN_C__)
extern "C" {
#endif
#ifndef yyerror
#if defined(__cplusplus)
	void yyerror(const char *);
#endif
#endif
#ifndef yylex
	int yylex(void);
#endif
	int yyparse(void);
#if defined(__cplusplus) && defined(__EXTERN_C__)
}
#endif

#endif

#define yyclearin yychar = -1
#define yyerrok yyerrflag = 0
extern int yychar;
extern int yyerrflag;
YYSTYPE yylval;
YYSTYPE yyval;
typedef int yytabelem;
#ifndef YYMAXDEPTH
#define YYMAXDEPTH 150
#endif
#if YYMAXDEPTH > 0
int yy_yys[YYMAXDEPTH], *yys = yy_yys;
YYSTYPE yy_yyv[YYMAXDEPTH], *yyv = yy_yyv;
#else	/* user does initial allocation */
int *yys;
YYSTYPE *yyv;
#endif
static int yymaxdepth = YYMAXDEPTH;
# define YYERRCODE 256

# line 184 "errores.y"


/*******************************************************************************************/
/* Funcin principal */
main( int argc, char ** argv ){
FILE *file;
extern yydebug;


  yydebug = 0;
  /* comprobacion de parametros y apertura del fichero */
  if (argc > 1){
    file = fopen(argv[1], "r");
    if ( !file ){
      fprintf(stderr, "no se puede abrir %s\n", argv[1] );
      exit(1);
    }
  } /* if */
  else {
    printf("Forma de uso: a.out fichero.c\n");
    exit (1);
  }

   yyin = file;
  /* creamos el fichero de salida */
  output = fopen("salida.err","w+");
  if (!output) {
    fprintf(stderr, "\nNo se puede crear el fichero de salida\n");
    exit(1);
  }

  /* Creamos la tabla de palabras reservadas */
   CrearRWtable(); 

  /* Creamos la tabla de simbolos */

  init();
  
  yyparse();
  fclose(output);
  fclose(file);
}
static const yytabelem yyexca[] ={
-1, 1,
	0, -1,
	-2, 0,
-1, 2,
	0, 1,
	-2, 0,
-1, 41,
	59, 56,
	41, 56,
	-2, 0,
-1, 52,
	123, 22,
	-2, 0,
-1, 53,
	41, 27,
	-2, 0,
-1, 102,
	123, 20,
	-2, 0,
-1, 103,
	123, 21,
	-2, 0,
-1, 144,
	123, 19,
	-2, 0,
	};
# define YYNPROD 101
# define YYLAST 425
static const yytabelem yyact[]={

    50,    12,    10,     4,    10,   146,   105,   104,   163,    50,
    82,    83,   149,   148,   150,    80,    78,   100,    79,    24,
    81,     7,    99,     7,    10,   106,   106,    18,    24,    50,
    22,    16,    10,    86,    54,    87,    24,   155,    50,    54,
    54,    50,    58,    10,    50,    24,   103,    30,    24,    42,
    54,    50,    13,    82,    83,    27,   139,    71,    80,    78,
    24,    79,   107,    81,    82,    83,    70,    85,    76,    80,
    78,    50,    79,    50,    81,    64,    86,    20,    87,    48,
    98,    26,    60,    35,    45,    31,    41,    86,    17,    87,
    82,    68,    35,    53,    31,    80,    78,    84,    79,    82,
    81,    92,    51,    25,    80,    78,    19,    79,    64,    81,
    85,   145,    35,    86,    34,    87,    64,    67,     3,     6,
     2,    11,    86,   110,    87,     1,   116,   118,   119,   120,
   121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
   131,   132,   133,   134,   135,   136,   137,   138,   141,   144,
     0,     0,   145,    33,     0,    75,    82,     0,    64,   147,
     0,    80,    78,    82,    79,   101,    81,    21,    80,     8,
     0,     0,     0,    81,     0,     0,     0,    14,     0,     0,
     0,     0,     0,     0,     0,   113,   114,     0,    66,     0,
     0,     0,    72,    73,    74,     0,     0,     0,     0,     0,
   158,   159,     0,     0,     0,   160,   162,     0,     0,     0,
     0,   164,     0,     0,     0,     0,    43,    44,    49,    36,
     0,    37,    38,    39,    40,    43,    44,    49,    36,   115,
    37,    38,    39,    40,    46,    47,    32,     0,    88,    89,
    90,    91,    23,    46,    47,    43,    44,    49,    36,   156,
    37,    38,    39,    40,   142,    44,    49,    43,    44,    49,
   161,    44,    49,    46,    47,    56,    55,   117,    44,    49,
    52,     0,    46,    47,   108,    46,    47,     0,    46,    47,
    77,    88,    89,    90,    91,    46,    47,    43,    44,    49,
    44,    49,    88,    89,    90,    91,    28,     0,     0,     0,
     0,   157,     0,     0,     0,    46,    47,    46,    47,    93,
    94,    95,    96,    97,     0,     5,     0,     9,    88,    89,
    90,    91,   102,    61,    63,    15,     0,    88,    89,     0,
     0,     0,    69,     0,    29,     0,     0,     0,     0,     0,
    57,    59,    62,     0,     0,     0,     0,     0,     0,     0,
    65,    29,     0,     0,     0,     0,     0,   109,     0,     0,
     0,     0,     0,     0,   111,   112,     0,     0,     0,   140,
     0,     0,   143,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,    62,   152,   153,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,   151,     0,     0,
   154,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,    65 };
static const yytabelem yypact[]={

  -253,-10000000,  -255,-10000000,-10000000,-10000000,-10000000,  -225,   -96,    37,
-10000000,-10000000,-10000000,   -14,   -96,    37,-10000000,-10000000,   -40,-10000000,
     9,-10000000,  -214,  -233,-10000000,-10000000,   -40,   -31,-10000000,-10000000,
-10000000,-10000000,  -225,-10000000,   -23,   -40,    26,    17,   -23,   -23,
     1,    24,   -27,-10000000,    40,-10000000,  -235,  -240,-10000000,-10000000,
    31,    -1,  -250,    18,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,
   -31,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,   -40,   -31,-10000000,
    31,    31,-10000000,-10000000,-10000000,   -23,    11,    33,    33,    33,
    33,    33,    33,    33,    33,    33,    33,    33,    33,    33,
    33,    33,    33,    33,    33,    33,    33,    33,    -2,-10000000,
-10000000,    -1,  -250,  -251,-10000000,-10000000,  -225,  -244,  -243,-10000000,
   -31,-10000000,-10000000,    -1,    -1,-10000000,   -27,-10000000,   -27,   126,
   126,-10000000,-10000000,-10000000,    53,    16,    27,   119,   119,   119,
   119,    62,    62,   -27,   -27,   -27,   -27,   -27,   -27,    -7,
-10000000,   -27,-10000000,-10000000,  -251,-10000000,-10000000,   -14,-10000000,-10000000,
-10000000,-10000000,   -11,   -11,-10000000,     4,    33,-10000000,  -252,-10000000,
   -27,-10000000,   -27,   -11,-10000000 };
static const yytabelem yypgo[]={

     0,   125,   120,   118,   315,   119,    52,   153,   317,   169,
    88,   106,   102,   270,    46,     7,    93,    81,    55,   296,
    47,   114,    86,    49,    84,    79,    56 };
static const yytabelem yyr1[]={

     0,     1,     2,     2,     2,     2,     3,     3,     4,     6,
     6,     6,     6,     6,     6,     8,     5,     5,     9,    11,
    11,    11,    11,    14,    14,    14,    14,    12,    16,    16,
    16,    16,    16,    16,    15,    10,    10,    10,    10,    17,
    17,    18,    18,    20,    20,    20,    20,    20,    20,    20,
    20,    20,    20,    20,    20,    20,    21,    22,    22,    22,
    22,    22,    22,    23,    23,    23,    23,    23,    23,    23,
    23,    23,    23,    23,    23,    23,    23,    23,    23,    23,
    23,    23,    23,    23,    24,    24,    24,    25,    25,    25,
    25,    25,    26,    26,    26,    26,    26,    26,     7,    13,
    19 };
static const yytabelem yyr2[]={

     0,     2,     2,     5,     2,     4,     2,     2,     6,     2,
     6,     2,     4,     7,     6,     2,     4,     6,     4,     8,
     6,     6,     4,     2,     5,     2,     4,     2,     2,     7,
     2,     4,     7,     6,     6,     8,     6,     6,     4,     2,
     5,     2,     5,     2,     4,     8,     6,     6,     4,    10,
    14,    10,     4,     4,     4,     6,     2,     2,     7,     2,
     4,     7,     6,     6,     6,     6,     6,     6,     6,     6,
     6,     6,     6,     6,     6,     6,     6,     6,     6,     6,
     6,     6,     6,     2,     4,     4,     2,     2,     2,     6,
     8,     6,     2,     7,     2,     4,     7,     6,     3,     3,
     3 };
static const yytabelem yychk[]={

-10000000,    -1,    -2,    -3,   256,    -4,    -5,   276,    -9,    -8,
   257,    -3,   256,    -6,    -9,    -8,   256,   -10,   123,   -11,
    40,    -7,    44,   256,    59,   -10,   -17,   -18,   -19,    -4,
   -20,   125,   276,    -7,   -21,   123,   259,   261,   262,   263,
   264,   -22,   -23,   256,   257,   -24,   274,   275,   -25,   258,
    40,   -12,   -13,   -16,    41,   257,   256,    -8,   256,    -8,
   -18,   -19,    -4,   -19,   -20,    -8,    -7,   -17,   -18,   -19,
    40,    40,    -7,    -7,    -7,   -21,    44,   256,    43,    45,
    42,    47,    37,    38,   124,    94,    60,    62,   265,   266,
   267,   268,    61,   269,   270,   271,   272,   273,    40,   257,
   257,   -21,   -13,   -14,   -15,   256,   276,    44,   256,   -19,
   -18,   -19,   -19,   -21,   -21,    -7,   -23,   256,   -23,   -23,
   -23,   -23,   -23,   -23,   -23,   -23,   -23,   -23,   -23,   -23,
   -23,   -23,   -23,   -23,   -23,   -23,   -23,   -23,   -23,   -26,
   -13,   -23,   256,   -13,   -14,   -15,   256,    -6,   257,   256,
   257,   -19,   -13,   -13,   -13,    44,   256,    -7,   -20,   -20,
   -23,   256,   -23,   260,   -20 };
static const yytabelem yydef[]={

     0,    -2,    -2,     2,     4,     6,     7,     0,     0,     0,
    15,     3,     5,     0,     0,     9,    11,    16,     0,    18,
     0,     8,     0,    12,    98,    17,     0,     0,    38,    39,
    41,   100,     0,    43,     0,     0,     0,     0,     0,     0,
     0,    -2,    57,    59,    87,    83,     0,     0,    86,    88,
     0,     0,    -2,    -2,    99,    28,    30,    10,    14,    13,
     0,    36,    40,    37,    42,     9,    44,     0,     0,    48,
     0,     0,    52,    53,    54,     0,     0,    60,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,    84,
    85,     0,    -2,    -2,    23,    25,     0,     0,    31,    35,
     0,    46,    47,     0,     0,    55,    58,    62,    61,    69,
    70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
    80,    81,    82,    63,    64,    65,    66,    67,    68,     0,
    91,    92,    94,    89,    -2,    24,    26,     0,    29,    33,
    32,    45,     0,     0,    90,     0,    95,    34,    49,    51,
    93,    97,    96,     0,    50 };
typedef struct
#ifdef __cplusplus
	yytoktype
#endif
{ char *t_name; int t_val; } yytoktype;
#ifndef YYDEBUG
#	define YYDEBUG	0	/* don't allow debugging */
#endif

#if YYDEBUG

yytoktype yytoks[] =
{
	"ID",	257,
	"CONST",	258,
	"IF",	259,
	"ELSE",	260,
	"WHILE",	261,
	"BREAK",	262,
	"CONTINUE",	263,
	"RETURN",	264,
	"GE",	265,
	"LE",	266,
	"EQ",	267,
	"NE",	268,
	"PE",	269,
	"ME",	270,
	"TE",	271,
	"DE",	272,
	"RE",	273,
	"PP",	274,
	"MM",	275,
	"INT",	276,
	";",	59,
	"=",	61,
	"|",	124,
	"^",	94,
	"&",	38,
	"<",	60,
	">",	62,
	"+",	43,
	"-",	45,
	"*",	42,
	"/",	47,
	"%",	37,
	"UNARIO",	277,
	"(",	40,
	")",	41,
	"-unknown-",	-1	/* ends search */
};

char * yyreds[] =
{
	"-no such reduction-",
	"program : definitionL",
	"definitionL : definition",
	"definitionL : definitionL definition",
	"definitionL : error",
	"definitionL : definitionL error",
	"definition : dataDefinition",
	"definition : functionDefinition",
	"dataDefinition : INT declaratorL PYC",
	"declaratorL : declarator",
	"declaratorL : declaratorL ',' declarator",
	"declaratorL : error",
	"declaratorL : declaratorL error",
	"declaratorL : declaratorL error declarator",
	"declaratorL : declaratorL ',' error",
	"declarator : ID",
	"functionDefinition : functionHeader functionBody",
	"functionDefinition : INT functionHeader functionBody",
	"functionHeader : declarator parameterList",
	"parameterList : '(' identifierList CP parameterDeclarationL",
	"parameterList : '(' identifierList CP",
	"parameterList : '(' CP parameterDeclarationL",
	"parameterList : '(' CP",
	"parameterDeclarationL : parameterDeclaration",
	"parameterDeclarationL : parameterDeclarationL parameterDeclaration",
	"parameterDeclarationL : error",
	"parameterDeclarationL : parameterDeclarationL error",
	"identifierList : IDL",
	"IDL : ID",
	"IDL : IDL ',' ID",
	"IDL : error",
	"IDL : IDL error",
	"IDL : IDL error ID",
	"IDL : IDL ',' error",
	"parameterDeclaration : INT declaratorL PYC",
	"functionBody : '{' dataDefinitionL stamentL CLL",
	"functionBody : '{' dataDefinitionL CLL",
	"functionBody : '{' stamentL CLL",
	"functionBody : '{' CLL",
	"dataDefinitionL : dataDefinition",
	"dataDefinitionL : dataDefinitionL dataDefinition",
	"stamentL : stament",
	"stamentL : stamentL stament",
	"stament : PYC",
	"stament : expression PYC",
	"stament : '{' dataDefinitionL stamentL CLL",
	"stament : '{' dataDefinitionL CLL",
	"stament : '{' stamentL CLL",
	"stament : '{' CLL",
	"stament : IF '(' expression CP stament",
	"stament : IF '(' expression CP stament ELSE stament",
	"stament : WHILE '(' expression CP stament",
	"stament : BREAK PYC",
	"stament : CONTINUE PYC",
	"stament : RETURN PYC",
	"stament : RETURN expression PYC",
	"expression : binaryL",
	"binaryL : binary",
	"binaryL : binaryL ',' binary",
	"binaryL : error",
	"binaryL : binaryL error",
	"binaryL : binaryL error binary",
	"binaryL : binaryL ',' error",
	"binary : ID '=' binary",
	"binary : ID PE binary",
	"binary : ID ME binary",
	"binary : ID TE binary",
	"binary : ID DE binary",
	"binary : ID RE binary",
	"binary : binary '+' binary",
	"binary : binary '-' binary",
	"binary : binary '*' binary",
	"binary : binary '/' binary",
	"binary : binary '%' binary",
	"binary : binary '&' binary",
	"binary : binary '|' binary",
	"binary : binary '^' binary",
	"binary : binary '<' binary",
	"binary : binary '>' binary",
	"binary : binary GE binary",
	"binary : binary LE binary",
	"binary : binary EQ binary",
	"binary : binary NE binary",
	"binary : unary",
	"unary : PP ID",
	"unary : MM ID",
	"unary : primary",
	"primary : ID",
	"primary : CONST",
	"primary : '(' expression CP",
	"primary : ID '(' argumentList CP",
	"primary : ID '(' CP",
	"argumentList : binary",
	"argumentList : argumentList ',' binary",
	"argumentList : error",
	"argumentList : argumentList error",
	"argumentList : argumentList error binary",
	"argumentList : argumentList ',' error",
	"PYC : ';'",
	"CP : ')'",
	"CLL : '}'",
};
#endif /* YYDEBUG */
# line	1 "/usr/ccs/bin/yaccpar"
/*
 * Copyright (c) 1993 by Sun Microsystems, Inc.
 */

#pragma ident	"@(#)yaccpar	6.15	97/12/08 SMI"

/*
** Skeleton parser driver for yacc output
*/

/*
** yacc user known macros and defines
*/
#define YYERROR		goto yyerrlab
#define YYACCEPT	return(0)
#define YYABORT		return(1)
#define YYBACKUP( newtoken, newvalue )\
{\
	if ( yychar >= 0 || ( yyr2[ yytmp ] >> 1 ) != 1 )\
	{\
		yyerror( "syntax error - cannot backup" );\
		goto yyerrlab;\
	}\
	yychar = newtoken;\
	yystate = *yyps;\
	yylval = newvalue;\
	goto yynewstate;\
}
#define YYRECOVERING()	(!!yyerrflag)
#define YYNEW(type)	malloc(sizeof(type) * yynewmax)
#define YYCOPY(to, from, type) \
	(type *) memcpy(to, (char *) from, yymaxdepth * sizeof (type))
#define YYENLARGE( from, type) \
	(type *) realloc((char *) from, yynewmax * sizeof(type))
#ifndef YYDEBUG
#	define YYDEBUG	1	/* make debugging available */
#endif

/*
** user known globals
*/
int yydebug;			/* set to 1 to get debugging */

/*
** driver internal defines
*/
#define YYFLAG		(-10000000)

/*
** global variables used by the parser
*/
YYSTYPE *yypv;			/* top of value stack */
int *yyps;			/* top of state stack */

int yystate;			/* current state */
int yytmp;			/* extra var (lasts between blocks) */

int yynerrs;			/* number of errors */
int yyerrflag;			/* error recovery flag */
int yychar;			/* current input token number */



#ifdef YYNMBCHARS
#define YYLEX()		yycvtok(yylex())
/*
** yycvtok - return a token if i is a wchar_t value that exceeds 255.
**	If i<255, i itself is the token.  If i>255 but the neither 
**	of the 30th or 31st bit is on, i is already a token.
*/
#if defined(__STDC__) || defined(__cplusplus)
int yycvtok(int i)
#else
int yycvtok(i) int i;
#endif
{
	int first = 0;
	int last = YYNMBCHARS - 1;
	int mid;
	wchar_t j;

	if(i&0x60000000){/*Must convert to a token. */
		if( yymbchars[last].character < i ){
			return i;/*Giving up*/
		}
		while ((last>=first)&&(first>=0)) {/*Binary search loop*/
			mid = (first+last)/2;
			j = yymbchars[mid].character;
			if( j==i ){/*Found*/ 
				return yymbchars[mid].tvalue;
			}else if( j<i ){
				first = mid + 1;
			}else{
				last = mid -1;
			}
		}
		/*No entry in the table.*/
		return i;/* Giving up.*/
	}else{/* i is already a token. */
		return i;
	}
}
#else/*!YYNMBCHARS*/
#define YYLEX()		yylex()
#endif/*!YYNMBCHARS*/

/*
** yyparse - return 0 if worked, 1 if syntax error not recovered from
*/
#if defined(__STDC__) || defined(__cplusplus)
int yyparse(void)
#else
int yyparse()
#endif
{
	register YYSTYPE *yypvt = 0;	/* top of value stack for $vars */

#if defined(__cplusplus) || defined(lint)
/*
	hacks to please C++ and lint - goto's inside
	switch should never be executed
*/
	static int __yaccpar_lint_hack__ = 0;
	switch (__yaccpar_lint_hack__)
	{
		case 1: goto yyerrlab;
		case 2: goto yynewstate;
	}
#endif

	/*
	** Initialize externals - yyparse may be called more than once
	*/
	yypv = &yyv[-1];
	yyps = &yys[-1];
	yystate = 0;
	yytmp = 0;
	yynerrs = 0;
	yyerrflag = 0;
	yychar = -1;

#if YYMAXDEPTH <= 0
	if (yymaxdepth <= 0)
	{
		if ((yymaxdepth = YYEXPAND(0)) <= 0)
		{
			yyerror("yacc initialization error");
			YYABORT;
		}
	}
#endif

	{
		register YYSTYPE *yy_pv;	/* top of value stack */
		register int *yy_ps;		/* top of state stack */
		register int yy_state;		/* current state */
		register int  yy_n;		/* internal state number info */
	goto yystack;	/* moved from 6 lines above to here to please C++ */

		/*
		** get globals into registers.
		** branch to here only if YYBACKUP was called.
		*/
	yynewstate:
		yy_pv = yypv;
		yy_ps = yyps;
		yy_state = yystate;
		goto yy_newstate;

		/*
		** get globals into registers.
		** either we just started, or we just finished a reduction
		*/
	yystack:
		yy_pv = yypv;
		yy_ps = yyps;
		yy_state = yystate;

		/*
		** top of for (;;) loop while no reductions done
		*/
	yy_stack:
		/*
		** put a state and value onto the stacks
		*/
#if YYDEBUG
		/*
		** if debugging, look up token value in list of value vs.
		** name pairs.  0 and negative (-1) are special values.
		** Note: linear search is used since time is not a real
		** consideration while debugging.
		*/
		if ( yydebug )
		{
			register int yy_i;

			printf( "State %d, token ", yy_state );
			if ( yychar == 0 )
				printf( "end-of-file\n" );
			else if ( yychar < 0 )
				printf( "-none-\n" );
			else
			{
				for ( yy_i = 0; yytoks[yy_i].t_val >= 0;
					yy_i++ )
				{
					if ( yytoks[yy_i].t_val == yychar )
						break;
				}
				printf( "%s\n", yytoks[yy_i].t_name );
			}
		}
#endif /* YYDEBUG */
		if ( ++yy_ps >= &yys[ yymaxdepth ] )	/* room on stack? */
		{
			/*
			** reallocate and recover.  Note that pointers
			** have to be reset, or bad things will happen
			*/
			long yyps_index = (yy_ps - yys);
			long yypv_index = (yy_pv - yyv);
			long yypvt_index = (yypvt - yyv);
			int yynewmax;
#ifdef YYEXPAND
			yynewmax = YYEXPAND(yymaxdepth);
#else
			yynewmax = 2 * yymaxdepth;	/* double table size */
			if (yymaxdepth == YYMAXDEPTH)	/* first time growth */
			{
				char *newyys = (char *)YYNEW(int);
				char *newyyv = (char *)YYNEW(YYSTYPE);
				if (newyys != 0 && newyyv != 0)
				{
					yys = YYCOPY(newyys, yys, int);
					yyv = YYCOPY(newyyv, yyv, YYSTYPE);
				}
				else
					yynewmax = 0;	/* failed */
			}
			else				/* not first time */
			{
				yys = YYENLARGE(yys, int);
				yyv = YYENLARGE(yyv, YYSTYPE);
				if (yys == 0 || yyv == 0)
					yynewmax = 0;	/* failed */
			}
#endif
			if (yynewmax <= yymaxdepth)	/* tables not expanded */
			{
				yyerror( "yacc stack overflow" );
				YYABORT;
			}
			yymaxdepth = yynewmax;

			yy_ps = yys + yyps_index;
			yy_pv = yyv + yypv_index;
			yypvt = yyv + yypvt_index;
		}
		*yy_ps = yy_state;
		*++yy_pv = yyval;

		/*
		** we have a new state - find out what to do
		*/
	yy_newstate:
		if ( ( yy_n = yypact[ yy_state ] ) <= YYFLAG )
			goto yydefault;		/* simple state */
#if YYDEBUG
		/*
		** if debugging, need to mark whether new token grabbed
		*/
		yytmp = yychar < 0;
#endif
		if ( ( yychar < 0 ) && ( ( yychar = YYLEX() ) < 0 ) )
			yychar = 0;		/* reached EOF */
#if YYDEBUG
		if ( yydebug && yytmp )
		{
			register int yy_i;

			printf( "Received token " );
			if ( yychar == 0 )
				printf( "end-of-file\n" );
			else if ( yychar < 0 )
				printf( "-none-\n" );
			else
			{
				for ( yy_i = 0; yytoks[yy_i].t_val >= 0;
					yy_i++ )
				{
					if ( yytoks[yy_i].t_val == yychar )
						break;
				}
				printf( "%s\n", yytoks[yy_i].t_name );
			}
		}
#endif /* YYDEBUG */
		if ( ( ( yy_n += yychar ) < 0 ) || ( yy_n >= YYLAST ) )
			goto yydefault;
		if ( yychk[ yy_n = yyact[ yy_n ] ] == yychar )	/*valid shift*/
		{
			yychar = -1;
			yyval = yylval;
			yy_state = yy_n;
			if ( yyerrflag > 0 )
				yyerrflag--;
			goto yy_stack;
		}

	yydefault:
		if ( ( yy_n = yydef[ yy_state ] ) == -2 )
		{
#if YYDEBUG
			yytmp = yychar < 0;
#endif
			if ( ( yychar < 0 ) && ( ( yychar = YYLEX() ) < 0 ) )
				yychar = 0;		/* reached EOF */
#if YYDEBUG
			if ( yydebug && yytmp )
			{
				register int yy_i;

				printf( "Received token " );
				if ( yychar == 0 )
					printf( "end-of-file\n" );
				else if ( yychar < 0 )
					printf( "-none-\n" );
				else
				{
					for ( yy_i = 0;
						yytoks[yy_i].t_val >= 0;
						yy_i++ )
					{
						if ( yytoks[yy_i].t_val
							== yychar )
						{
							break;
						}
					}
					printf( "%s\n", yytoks[yy_i].t_name );
				}
			}
#endif /* YYDEBUG */
			/*
			** look through exception table
			*/
			{
				register const int *yyxi = yyexca;

				while ( ( *yyxi != -1 ) ||
					( yyxi[1] != yy_state ) )
				{
					yyxi += 2;
				}
				while ( ( *(yyxi += 2) >= 0 ) &&
					( *yyxi != yychar ) )
					;
				if ( ( yy_n = yyxi[1] ) < 0 )
					YYACCEPT;
			}
		}

		/*
		** check for syntax error
		*/
		if ( yy_n == 0 )	/* have an error */
		{
			/* no worry about speed here! */
			switch ( yyerrflag )
			{
			case 0:		/* new error */
				yyerror( "syntax error" );
				goto skip_init;
			yyerrlab:
				/*
				** get globals into registers.
				** we have a user generated syntax type error
				*/
				yy_pv = yypv;
				yy_ps = yyps;
				yy_state = yystate;
			skip_init:
				yynerrs++;
				/* FALLTHRU */
			case 1:
			case 2:		/* incompletely recovered error */
					/* try again... */
				yyerrflag = 3;
				/*
				** find state where "error" is a legal
				** shift action
				*/
				while ( yy_ps >= yys )
				{
					yy_n = yypact[ *yy_ps ] + YYERRCODE;
					if ( yy_n >= 0 && yy_n < YYLAST &&
						yychk[yyact[yy_n]] == YYERRCODE)					{
						/*
						** simulate shift of "error"
						*/
						yy_state = yyact[ yy_n ];
						goto yy_stack;
					}
					/*
					** current state has no shift on
					** "error", pop stack
					*/
#if YYDEBUG
#	define _POP_ "Error recovery pops state %d, uncovers state %d\n"
					if ( yydebug )
						printf( _POP_, *yy_ps,
							yy_ps[-1] );
#	undef _POP_
#endif
					yy_ps--;
					yy_pv--;
				}
				/*
				** there is no state on stack with "error" as
				** a valid shift.  give up.
				*/
				YYABORT;
			case 3:		/* no shift yet; eat a token */
#if YYDEBUG
				/*
				** if debugging, look up token in list of
				** pairs.  0 and negative shouldn't occur,
				** but since timing doesn't matter when
				** debugging, it doesn't hurt to leave the
				** tests here.
				*/
				if ( yydebug )
				{
					register int yy_i;

					printf( "Error recovery discards " );
					if ( yychar == 0 )
						printf( "token end-of-file\n" );
					else if ( yychar < 0 )
						printf( "token -none-\n" );
					else
					{
						for ( yy_i = 0;
							yytoks[yy_i].t_val >= 0;
							yy_i++ )
						{
							if ( yytoks[yy_i].t_val
								== yychar )
							{
								break;
							}
						}
						printf( "token %s\n",
							yytoks[yy_i].t_name );
					}
				}
#endif /* YYDEBUG */
				if ( yychar == 0 )	/* reached EOF. quit */
					YYABORT;
				yychar = -1;
				goto yy_newstate;
			}
		}/* end if ( yy_n == 0 ) */
		/*
		** reduction by production yy_n
		** put stack tops, etc. so things right after switch
		*/
#if YYDEBUG
		/*
		** if debugging, print the string that is the user's
		** specification of the reduction which is just about
		** to be done.
		*/
		if ( yydebug )
			printf( "Reduce by (%d) \"%s\"\n",
				yy_n, yyreds[ yy_n ] );
#endif
		yytmp = yy_n;			/* value to switch over */
		yypvt = yy_pv;			/* $vars top of value stack */
		/*
		** Look in goto table for next state
		** Sorry about using yy_state here as temporary
		** register variable, but why not, if it works...
		** If yyr2[ yy_n ] doesn't have the low order bit
		** set, then there is no action to be done for
		** this reduction.  So, no saving & unsaving of
		** registers done.  The only difference between the
		** code just after the if and the body of the if is
		** the goto yy_stack in the body.  This way the test
		** can be made before the choice of what to do is needed.
		*/
		{
			/* length of production doubled with extra bit */
			register int yy_len = yyr2[ yy_n ];

			if ( !( yy_len & 01 ) )
			{
				yy_len >>= 1;
				yyval = ( yy_pv -= yy_len )[1];	/* $$ = $1 */
				yy_state = yypgo[ yy_n = yyr1[ yy_n ] ] +
					*( yy_ps -= yy_len ) + 1;
				if ( yy_state >= YYLAST ||
					yychk[ yy_state =
					yyact[ yy_state ] ] != -yy_n )
				{
					yy_state = yyact[ yypgo[ yy_n ] ];
				}
				goto yy_stack;
			}
			yy_len >>= 1;
			yyval = ( yy_pv -= yy_len )[1];	/* $$ = $1 */
			yy_state = yypgo[ yy_n = yyr1[ yy_n ] ] +
				*( yy_ps -= yy_len ) + 1;
			if ( yy_state >= YYLAST ||
				yychk[ yy_state = yyact[ yy_state ] ] != -yy_n )
			{
				yy_state = yyact[ yypgo[ yy_n ] ];
			}
		}
					/* save until reenter driver code */
		yystate = yy_state;
		yyps = yy_ps;
		yypv = yy_pv;
	}
	/*
	** code supplied by user is placed in this switch
	*/
	switch( yytmp )
	{
		
case 3:
# line 57 "errores.y"
{yyerrok;} break;
case 13:
# line 70 "errores.y"
{yyerrok;} break;
case 24:
# line 86 "errores.y"
{yyerrok;} break;
case 29:
# line 93 "errores.y"
{yyerrok;} break;
case 32:
# line 96 "errores.y"
{yyerrok;} break;
case 40:
# line 107 "errores.y"
{yyerrok;} break;
case 42:
# line 112 "errores.y"
{yyerrok;} break;
case 58:
# line 133 "errores.y"
{yyerrok;} break;
case 61:
# line 136 "errores.y"
{yyerrok;} break;
case 93:
# line 172 "errores.y"
{yyerrok;} break;
case 96:
# line 175 "errores.y"
{yyerrok;} break;
case 98:
# line 178 "errores.y"
{yyerrok;} break;
case 99:
# line 180 "errores.y"
{yyerrok;} break;
case 100:
# line 182 "errores.y"
{yyerrok;} break;
# line	531 "/usr/ccs/bin/yaccpar"
	}
	goto yystack;		/* reset registers in driver code */
}

